# coding: utf-8

"""
    IBM Key Protect API

    IBM Key Protect helps you provision encrypted keys for apps across IBM Cloud. As you manage the lifecycle of your keys, you can benefit from knowing that your keys are secured by cloud-based FIPS 140-2 Level 2 hardware security modules (HSMs) that protect against theft of information. You can use the Key Protect API to store, generate, and retrieve your key material. Keys within the service can protect any type of data in your symmetric key based encryption solution.  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class CollectionMetadata(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'collection_type': 'str',
        'collection_total': 'int'
    }

    attribute_map = {
        'collection_type': 'collectionType',
        'collection_total': 'collectionTotal'
    }

    def __init__(self, collection_type='application/vnd.ibm.kms.key+json', collection_total=None):  # noqa: E501
        """CollectionMetadata - a model defined in OpenAPI"""  # noqa: E501

        self._collection_type = None
        self._collection_total = None
        self.discriminator = None

        self.collection_type = collection_type
        self.collection_total = collection_total

    @property
    def collection_type(self):
        """Gets the collection_type of this CollectionMetadata.  # noqa: E501

        The type of resources in the resource array.  # noqa: E501

        :return: The collection_type of this CollectionMetadata.  # noqa: E501
        :rtype: str
        """
        return self._collection_type

    @collection_type.setter
    def collection_type(self, collection_type):
        """Sets the collection_type of this CollectionMetadata.

        The type of resources in the resource array.  # noqa: E501

        :param collection_type: The collection_type of this CollectionMetadata.  # noqa: E501
        :type: str
        """
        if collection_type is None:
            raise ValueError("Invalid value for `collection_type`, must not be `None`")  # noqa: E501

        self._collection_type = collection_type

    @property
    def collection_total(self):
        """Gets the collection_total of this CollectionMetadata.  # noqa: E501

        The number of elements in the resource array.  # noqa: E501

        :return: The collection_total of this CollectionMetadata.  # noqa: E501
        :rtype: int
        """
        return self._collection_total

    @collection_total.setter
    def collection_total(self, collection_total):
        """Sets the collection_total of this CollectionMetadata.

        The number of elements in the resource array.  # noqa: E501

        :param collection_total: The collection_total of this CollectionMetadata.  # noqa: E501
        :type: int
        """
        if collection_total is None:
            raise ValueError("Invalid value for `collection_total`, must not be `None`")  # noqa: E501

        self._collection_total = collection_total

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CollectionMetadata):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
